#ifndef REQUEST_H
#define REQUEST_H

#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>
#include <string.h>
#include <netinet/in.h>
#include "readline.h"
#include "requestresponse.h"



/*
* A struct reperesenting an http request
*/
typedef struct {
	// Common versions are: 0.9, 1.0, 1.1, 2.0
	float version;
	char *method;
	char *protocol;
	char *host;
	char *path;
	HeaderList *headers;
	char *queryString;
	char *body;
} Request;

Request* newRequest();
void requestFirstLine( Request *req, char line[] );
Request* newRequestFromSocket(int socket);
/*
* requestToString
* @prarm req the request to convert
* @param proxy whether we want a proxy request (adds the host to the first line) 
*/
char* requestToString( Request *req, bool proxy );
void requestAddHeader( Request *req, char header[] );
//void* requestAddHeader(Request *req, char line[]);



#endif /* ifndef REQUEST_H */
