#ifndef RESPONSE_H
#define RESPONSE_H

#include <netinet/in.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdbool.h>

#include "readline.h"
#include "requestresponse.h"


/*
* A struct reperesenting an http request
*/
typedef struct {
	// Common versions are: 0.9, 1.0, 1.1, 2.0
	float version;
	int statusCode;
	char *statusMessage;
	HeaderList *headers;
	char *body;
	unsigned int headerLength;
} Response;

Response* newResponse();
char *responseToString(Response *rsp);
void responseSetBody(Response *rsp, char *string, bool updateContentLength);
void responseAddHeader(Response *rsp, char header[]);



#endif /* ifndef REQUEST_H */
